<id>
RollLog YaBB 2.1
</id>

<version>
1.1
</version>

<mod info>

Instructions:
Use BoardMod or manually edit files.

Upload (in ASCII mode):
Languages\English\RollLog.lng (CHMOD 777)
Sources\RollLog.pl (CHMOD 755)
Sources\SubList.pl (CHMOD 755)
Variables\dicelog.txt (CHMOD 666)
Admin\ModList.pl (CHMOD 666)
Templates\default\default.html (and any other templates 
 manually edited) 

Special Instructions:

If you use more templates than just the default.html, you will 
 want to copy the html code manually to those other templates.  
 This mod file will not do that for you.  Only the default.html 
 is modified.
Optionally, this HTML / JavaScript code could be added to
 its own page with something like the Custom Page mod.


General Features:

- Virtual rolling of 1 to 20 various polyhedron dice using 
  JavaScript.
- Add or subtract a modifying value.
- Add a text reason which is displayed on the dice log.
- Allow to repeat a number of times.
- Option to drop the lowest die of the number of dice rolled.
- Error checking to help prevent user-caused errors from 
  improper form use.
- Show the results without forcing a reload of the whole page 
  (if not logged) allows quick rolling.
- Verification of registered users to prevent unauthorized use 
  of bandwidth by logging spam messages.
- Display the last 30 days of logged rolls.
- Automatically trims the variables file so no manual 
  maintenance is required.
- Displays the newest rolls at the top of the list.
- Dice-rolling form is added to your template so it handily 
  shows up on every page visited (excluding the Admin center).

Revision Information:
Version 1.1 - Removed cookie reference and eliminated 
  JavaScript calculations for any logged entry - eliminating
  spoofing possibilities.  Also added some color formatting
  to prevent template color mismatches.
Version 1.0 - First Official Beta Release

Special Thanks:

Carsten & Monsen for developing the first dice mod in YaBB 1. 
  Even though I couldn't use any of it in this one, it 
  motivated me to complete the new dice-rolling mod for YaBB 2.
Astropilot for helping introduce me to the finer points of mod 
  development.  I couldn't have done it without ya bud.
AK108 - for leading me toward hash use to work with the date 
  comparisons and away from cookie reliance and possible 
  form submission spoofing. 

</mod info>

<author>
Imp_In_Training
</author>

<homepage>
http://darkandmoodyforums.com
</homepage>

<Edit file>
Admin\ModList.pl
</Edit file>

<Search for>
### END BOARDMOD ANCHOR ###
</Search for>

<Add before>
	$rolllog = "Roll Log Mod|Thomas Dawe (Imp_In_Training)|Roll 1 to 20 virtual polyhedron dice and log the results.|1.0|2006-06-23";
	push (@installed_mods, "$rolllog");
</Add before>

<Edit file>
Sources\SubList.pl
</Edit file>

<Search for>
%director=(
</Search for>

<Add after>
'logroll',"RollLog.pl&LogRoll",
'logrolldisplay',"RollLog.pl&RollLogDisplay",
</Add after>

<Edit file>
Templates\default\default.html
</Edit file>

<Search for>
</head>
</Search for>

<Add before>
</script>
<script language="JavaScript" type="text/javascript">
  <!-- BEGIN Dice Roller script - Added with RollLog mod.
    var die = 20;
    var dice = 1;
    var mod = 0;
    var loop = 0;
    var dicerolled = null;

    function dice_roll(sides, dice, mod, repeat) {
      if (repeat > 0 && document.rollform.rolllog.checked == false) {
        window.alert("Repeating rolls only works with the Dice Log function.");
      }
      if (repeat > 10) {
        window.alert("You can only repeat a maximum of 10 times.");
      } else if (dice >20 || dice <1) {
        window.alert("Please enter 1 to 20 dice.");
      } else if (dice == 1 && document.rollform.droplow.checked == true) {
        window.alert("If you wish to 'drop lowest', you need to roll more than one die.");
      } else {
        var roll = new Array(dice);
        var rolltot = 0;
        for (loop=0; loop < dice; loop++) {
          if (sides == "SEG") {
            roll[loop] = Math.floor(Math.random()*6);
          } else {
            roll[loop] = Math.floor(Math.random() * sides) + 1;
          }
          if (loop == 0) {
            dicerolled = roll[loop];
            var lowdie = roll[loop];
          } else {
            dicerolled = dicerolled + " " + roll[loop];
            if (roll[loop] < lowdie) {
              lowdie = roll[loop];
            }
          }
          rolltot = parseInt(rolltot) + parseInt(roll[loop]) 
        }
        rolltot = (parseInt(rolltot) + parseInt(mod));
        if (document.rollform.droplow.checked == true) {
          rolltot = (parseInt(rolltot) - parseInt(lowdie));
          dice -= 1;
          document.rollform.textdroplow.value = "drop";           
        } else {
          document.rollform.textdroplow.value = "keep";
        }
        document.rollform.textdice.value = dice;
        document.rollform.textdie.value = sides;
        document.rollform.textmod.value = mod;
        if (document.rollform.rolllog.checked == false){
          document.rollform.textrolltot.value = rolltot;
          document.rollform.textdicerolled.value = dicerolled;
        }
        if (document.rollform.rolllog.checked == true){
          document.rollform.textdateroll.value = Date();
          document.rollform.submit();
        }
      }
    }
  // END Dice Roller Script-->
</script>
</Add before>


<Search for>
<div class="copyright" style="text-align: center;">
<br />
<yabb copyright><br /><br />
<a href="http://validator.w3.org/check/referer" target="_blank"><img src="<yabb images>/xhtml.gif" alt="Valid XHTML" border="0" /></a>
<a href="http://jigsaw.w3.org/css-validator/" target="_blank"><img src="<yabb images>/css.gif" alt="Valid CSS" border="0" /></a>
<a href="http://www.perl.com" target="_blank"><img src="<yabb images>/perl.gif" alt="Powered by Perl" border="0" /></a>
<a href="http://www.sf.net/projects/yabb" target="_blank"><img src="<yabb images>/sf.gif" alt="Source Forge" border="0" /></a><br />
<yabb debug>
<br /><br />
</div>
</Search for>

<Replace>
<div class="copyright" style="text-align: center;">
  <table style="padding: 5">
    <tr>
      <td bgcolor="000000">
        <form name="rollform" id="rollform" method="post" 
          action="http://darkandmoodyforums.com/cgi-bin/yabb2/YaBB.pl?action=logroll">
          <fieldset>
            <legend style="color: #ff0000; font-family: verdana; font-size: 14pt;">Dice Roller</legend>
            <table style="padding: 5; color: white">
              <tr>
                <td style="text-align: center; border: gray 1px solid">
                  What dice type?
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  How many dice to roll?
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  Modifier
                </td>
              </tr>
              <tr>
                <td style="vertical-align: top; text-align: middle; border: gray 1px solid">
                  <select name="sides" id="sides">
                    <option value="3">3 sided</option>
                    <option value="4">4 sided</option>
                    <option value="5">5 sided</option>
                    <option value="SEG">6 sided -1</option>
                    <option value="6">6 sided</option>
                    <option value="8">8 sided</option>
                    <option value="10">10 sided</option>
                    <option value="12">12 sided</option>
                    <option selected="selected" value="20">20 sided</option>
                    <option value="30">30 sided</option>
                    <option value="100">100 sided</option>
                  </select>
                </td>
                <td style="vertical-align: top; text-align: center; border: gray 1px solid">
                  <label for="dice">(20 or less)</label>
                  <input type="text" name="dice" id="dice" size="5" value="1" title="How many dice to roll?" />
                </td>
                <td style="vertical-align: top; text-align: center; border: gray 1px solid">
                  <input type="text" name="mod" id="mod" size="10" value="0" title="Add or subtract from the total?" />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="2">
                  <label for="textreason">Reason</label>
                  <input type="text" size="35" name="textreason" id="textreason" title="Identify the purpose for the roll." />
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  <label for="rolllog">Log?</label>
                  <input type="checkbox" name="rolllog" id="rolllog" value="Log" title="Writes results to a dice roll file for proof." />
                  <input type="hidden" name="textdateroll" id="textdateroll" />
                  <input type="hidden" name="textdroplow" id="textdroplow" />
                </td>
              </tr>
              <tr>
                <td style="border: gray 1px solid">
                  <label for="repeat">Repeat</label>
                  <input type="text" name="repeat" id="repeat" size="1" value="0" title="Make this roll more than one time?" /> x
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  <label for="droplow">Drop Lowest</label>
                  <input type="checkbox" name="droplow" id="droplow" value="yes" title="Will drop the lowest of the die rolls in each sequence." />
                </td>
                <td style="border: gray 1px solid">
                  <input type="button" value="Roll Dice" name="RollDice" id="RollDice" onclick="dice_roll(sides.value, dice.value, mod.value, repeat.value);" />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="3">
                  <label for="textdicerolled">Dice Rolled</label>
                  <input type="text" size="35" name="textdicerolled" id="textdicerolled" title="Shows each individual die roll in the sequence." />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="3">
                  <label for="textdice">Dice Results</label>
                  <input type="text" size="5" name="textdice" id="textdice" title="How many dice rolled." />d
                  <input type="text" size="5" name="textdie" id="textdie" title="How many sides on each die." /> +
                  <input type="text" size="5" name="textmod" id="textmod" title="Modifier to the roll total." /> = 
                  <input type="text" size="5" name="textrolltot" id="textrolltot" title="End Result" /> 
                </td>
              </tr>
            </table>
          </fieldset>
        </form>
        <a href="http://darkandmoodyforums.com/cgi-bin/yabb2/YaBB.pl?action=logrolldisplay" target="dicelog">See the Dice Log</a>
      </td>
      <td>
        <yabb copyright>
        <br />
        <br />
        <a href="http://validator.w3.org/check/referer" target="_blank">
          <img src="<yabb images>/xhtml.gif" alt="Valid XHTML" border="0" />
        </a>
        <a href="http://jigsaw.w3.org/css-validator/" target="_blank">
          <img src="<yabb images>/css.gif" alt="Valid CSS" border="0" />
        </a>
        <a href="http://www.perl.com" target="_blank">
          <img src="<yabb images>/perl.gif" alt="Powered by Perl" border="0" />
        </a>
        <a href="http://www.sf.net/projects/yabb" target="_blank">
          <img src="<yabb images>/sf.gif" alt="Source Forge" border="0" />
        </a>
        <br />
        <yabb debug>
        <br />
      </td>
    </tr>
  </table>
  <br />
  <br />
</div>
</Replace>