###############################################################################
# RollLog.pl 1.0                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################
# This file is part of the RollLog Mod which has been created by              #
# Thomas Dawe (aka Imp_In_Training). Last modification: 08.23.06              #
###############################################################################
# file formats used by this code:
#
#  dicelog.txt - This file contains all logged rolls in HTML format.  
#    The details of each roll occupy the same physical line in the text file.
#  -------------
#  ...
#  <tr><td>Tue Jul 25 18:44:06 2006</td><td>Nimbus Thantos</td><td>1 d 20</td><td>2</td><td>5</td><td>7</td><td>Listen Check</td></tr>
#  <tr><td>Tue Jul 25 20:04:55 2006</td><td>Zamara</td><td>1 d 20</td><td>+4</td><td>2</td><td>6</td><td>spot</td></tr>
#  <tr><td>Tue Jul 25 21:37:25 2006</td><td>Xaine</td><td>1 d 20</td><td>7</td><td>8</td><td>15</td><td>Listen Bacchius</td></tr>
#  ...
#
###############################################################################

LoadLanguage("RollLog");

sub LogRoll {

fatal_error("$RollLog{'23'}") if $iamguest;

	## Get Results from the form html submission.
	
	my $sides = $FORM{'textdie'};
	my $dice = $FORM{'textdice'};
	my $mod = $FORM{'textmod'};
	## my $rolltot = $FORM{'textrolltot'};
	my $userroll = ${$uid.$username}{'realname'};
	my $dateroll = $FORM{'textdateroll'};
	my $reason = $FORM{'textreason'};
	my $repeat = $FORM{'repeat'};
	my $droplow = $FORM{'textdroplow'};

	if ($droplow eq "drop") {
	  $dice++;
	}

	## Log to file.  Each line appended to the file dicelog.txt is a separate
	## log entry kept in html code for easy display when someone wishes to 
	## view the dicelog.txt results.
	
	fopen(ROLLLOG, ">>$vardir/dicelog.txt") || die "$RollLog{'1'} $!";
	print ROLLLOG "<tr><td>$dateroll</td>";
	print ROLLLOG "<td>$userroll</td>"; 
	print ROLLLOG "<td>$dice d $sides";
	if ($droplow eq "drop") {
	  print ROLLLOG "<br />$RollLog{'2'}";
	}
	print ROLLLOG "</td>";
	print ROLLLOG "<td>$mod</td>";
	## if ($repeat == 0) {
	##  print ROLLLOG "<td>$dicerolled</td>";
	##	print ROLLLOG "<td>$rolltot</td>";
	## } else {

	  ## It was easier to have Perl rerun the calculations normally done in
		## JavaScript than to have the form resubmit repeatedly.  This section 
		## only happens when there is a number > 0 in the repeat box.

    ## print ROLLLOG "<td>$dicerolled<br />";
		## @rolltot[0] = $rolltot;
	print ROLLLOG "<td>";
	if ($repeat == 0) {$repeat++}
  for ($i=0; $i<$repeat; $i++) {
    for ($loop=0; $loop < $dice; $loop++) {
      if ($sides == "SEG") {
        $roll[$loop] = int(rand 6);
      } else {
        $roll[$loop] = int(rand $sides) + 1;
      }
      $rolltot[$i] = $rolltot[$i] + $roll[$loop];
			print ROLLLOG $roll[$loop];
			print ROLLLOG " ";
		  if ($loop == 0) {
			  $lowdie = $roll[$loop];
			} 
		  if ($roll[$loop] < $lowdie) {
			  $lowdie = $roll[$loop];
			}
    }
		if ($repeat > 0) {
	    print ROLLLOG "<br />";
		}
	  if ($droplow eq "drop") {
      $rolltot[$i] = $rolltot[$i] + $mod - $lowdie;
	  } else {
	    $rolltot[$i] = $rolltot[$i] + $mod;
	  }
	}
	print ROLLLOG "</td><td>";
	for ($i=0; $i<$repeat; $i++) {print ROLLLOG "$rolltot[$i]<br />"};
	print ROLLLOG "</td>";

  print ROLLLOG "<td>$reason</td></tr>\n";
  fclose(ROLLLOG);

  ## Redirect to BoardIndex.pl  $scripturl 

  $yySetLocation = qq~$scripturl~; 
  &redirectexit;
}

sub RollLogDisplay {

  ## Open the file dicelog.txt and add the information to the @rolllog array.

	fopen(ROLLLOG, "$vardir/dicelog.txt") || die "$RollLog{'1'} $!";
	@rolllog = <ROLLLOG>;
	fclose(ROLLLOG);

	## This preempts the while loop below to identify the date of the oldest 
	## entry and current date.

	my $oldest = $rolllog[0];
	my $oldestDate = substr($oldest, 12, 6);
	my $today = localtime(time);
	my $todaysDate = substr($today, 4, 6);

	## compareDate subroutine will return a 1 if the oldest log entry is > 30 
	## days, otherwise returns a 0 and nothing is done.

	while (compareDate($todaysDate, $oldestDate) == 1) {

		##    Remove oldest roll

		shift @rolllog;
		$oldest = $rolllog[0];
  	$oldestDate = substr($oldest, 12, 6);
	  $today = localtime(time);
	  $todaysDate = substr($today, 4, 6);
	}

	## A zero is returned from function compareDate and the array is 
	## over-writing the dicelog.txt file

  fopen(ROLLLOG, ">$vardir/dicelog.txt") || die "$RollLog{'1'} $!";
	print ROLLLOG @rolllog;
	fclose(ROLLLOG);

	## Setup column titles

  $yymain .= qq~<center>~;
  $yymain .= qq~<table style="background-color: gray; border: gold 4px outset; color: white" rules="all" cellpadding="4" summary="This table represents a virtual dice roller form">~;
	$yymain .= qq~<caption style="font-weight: bold; color: yellow; font-size: 2em">$RollLog{'3'}</caption>~;
	$yymain .= qq~<th>$RollLog{'4'}</th>~;
	$yymain .= qq~<th>$RollLog{'5'}</th>~;
	$yymain .= qq~<th>$RollLog{'6'}</th>~;
	$yymain .= qq~<th>$RollLog{'7'}</th>~;
	$yymain .= qq~<th>$RollLog{'8'}</th>~;
	$yymain .= qq~<th>$RollLog{'9'}</th>~;
	$yymain .= qq~<th>$RollLog{'10'}</th>~;

	## swap the order of rolls so newest is on top and print to screen

	foreach (reverse(@rolllog)){
		$yymain .= qq~$_~;
	}
	$yymain .= qq~</table>~;
	$yymain .= qq~</center>~;	
		
	&template;
	exit;	
}

sub compareDate {

  ## extract month and day from the information provided to this subroutine.

  my $todaysMonth = substr($_[0], 0, 3);
	my $todaysDay = substr($_[0], 4, 2);
  my $oldestMonth = substr($_[1], 0, 3); 
	my $oldestDay = substr($_[1], 4, 2);

	## convert month to number of days already passed in the year.

  my %convertMonthToDays = (
	  $RollLog{'11'} => 0,
		$RollLog{'12'} => 31,
		$RollLog{'13'} => 59,
		$RollLog{'14'} => 90,
		$RollLog{'15'} => 120,
		$RollLog{'16'} => 151,
		$RollLog{'17'} => 181,
		$RollLog{'18'} => 212,
		$RollLog{'19'} => 243,
		$RollLog{'20'} => 273,
		$RollLog{'21'} => 304,
		$RollLog{'22'} => 334
	); 

	## add the day number to the converted month / day count.

	my $currentDayCount = $convertMonthToDays{$todaysMonth} + $todaysDay;
	my $oldestDayCount = $convertMonthToDays{$oldestMonth} + $oldestDay;

	## Compare that the oldest log entry is within a 30 day period from 
	## current date.

  if ($currentDayCount < $oldestDayCount + 30 || $currentDayCount - $oldestDayCount < -334) {
	  return (0);
	}

	## Compare failed and oldest log entry should be removed.

	return (1);
}

1; 